# Nejprve si vytvoříme testovací soubor.

# Úkol: Napište funkci, která do souboru uloží čísla v zadaném intervalu.
# Každé číslo bude na samostatném řádku.
def file_range(path, m, n):
    with open(path, "w") as file:
        for i in range(m, n):
            file.write(str(i) + "\n")
            
        
# Například volání:
"""
file_range("numbers.txt", 5, 10)
"""
# vytvoří soubor numbers.txt:
"""
5
6
7
8
9
"""

# Úkol: Uložte do výstupního souboru pouze sudá čísla
# nacházející se ve vstupním souboru.
#
# Můžete předpokládat, že se vám obsah souboru vejde do paměti.
from file import load_file_content, parse_lines, store_file_content
from array_fun import map_array, filter_array

# Úkol: Napište funkci, která převede řetězec,
# kde na každém řádku je jedno celé číslo, na pole čísel.
def parse_numbers(string):
    lines = parse_lines(string)
    return map_array(int, lines)
    
"""
>>> parse_numbers("1\n2\n33\n")
[1, 2, 33]
"""
def is_even(n):
    return  n % 2 == 0

def filter_even(array):
    return filter_array(is_even, array)

"""
>>> filter_even([1, 2, 3, 4])
[2, 4]
"""
# Metoda join řetězce.
"""
>>> "-".join(["a", "b", "c"])
'a-b-c'
"""
# Napište funkci, která převede pole čísel na řetězec,
# kde na každém řádku bude zápis jednoho prvku pole.
def stringify_numbers(numbers):
    lines = map_array(str, numbers)
    return "\n".join(lines)    
"""
>>> stringify_numbers([1, 2, 3])
'1\n2\n3'
"""
# Funkce parse_numbers a stringify_numbers jsou inverzní.
"""
>>> parse_numbers(stringify_numbers([1, 2, 3]))
[1, 2, 3]
>>> stringify_numbers(parse_numbers("1\n2\n3"))
'1\n2\n3'
"""

# Napište funkci, která načte pole čísel ze souboru.
def load_numbers(path):
    return parse_numbers(load_file_content(path))

"""
>>> load_numbers("numbers.txt")
[5, 6, 7, 8, 9]
"""

# Napište funkci, která uloží pole čísel do souboru.
def store_numbers(path, numbers):
    store_file_content(path, stringify_numbers(numbers))

"""
store_numbers("test.txt", [1, 2, 3])
"""
# test.txt
"""
1
2
3
"""
# Napište funkci, která uloží do cílového souboru
# pouze sudá čísla ze zdrojového souboru.
def file_numbers_filter_even(source_path, target_path):
    numbers = load_numbers(source_path)
    even_numbers = filter_even(numbers)
    store_numbers(target, target_path)
    
"""
file_numbers_filter_even("numbers.txt", "even_numbers.txt")
"""
# even_numbers.txt
"""
6
8
"""
# Napište funkci, která do cílového souboru uloží pouze čísla
# ze zdrojového souboru, která splňují zadaný predikát.
def file_numbers_filter(predicate, source_path, target_path):
    numbers = load_numbers(source_path)
    result_numbers = filter_array(predicate, numbers)
    store_numbers(target_path, result_numbers)
"""
file_numbers_filter(is_even, "numbers.txt", "even_numbers2.txt")
"""
# even_numbers2.txt
"""
6
8
"""
