# Postupné zpracovávání souboru.

# Úkol: Uložit do souboru pouze sudá čísla
# nacházející se v zadaném souboru.
# Není možné celý soubor načíst do paměti.

# numbers.txt:
"""
5
6
7
8
9
"""
# Zpracování souboru po řádcích:
"""
with open("numbers.txt") as file:
    for line in file:
        print(line)
"""
def file_numbers_filter_even(source_path, target_path):
    with open(source_path) as file1:
        with open(target_path, "w") as file2:
            for line in file1:
                n = int(line)
                if n % 2 == 0:
                    file2.write(str(n) + '\n')
"""
file_numbers_filter_even("numbers.txt", "even_numbers.txt")
"""

# Napište funkci, která do cílového souboru uloží pouze řádky
# ze zdrojového souboru splňující predikát.
# Soubor se zpracovává řádek po řádku.
def file_line_filter(predicate, source_path, target_path):
    with open(source_path) as source_file:
        with open(target_path, "w") as target_file:
            for line in source_file:
                if predicate(line):
                    target_file.write(line)
                    
def is_line_even(line):
    return int(line) % 2 == 0

"""
file_line_filter(is_line_even, 'numbers.txt', 'even_numbers5.txt')
"""

# even_numbers5.txt
"""
6
8
"""

                
