# Aplikace: zpracování TSV formátu
# Z minulého semináře:
def parse_tsv_line(row):
    return row.replace("\n", "").split("\t")

"""
>>> parse_tsv_line('tt0033290\tYoung as You Feel\t1940\t60\n')
['tt0033290', 'Young as You Feel', '1940', '60']
>>> parse_tsv_line('tt0033290\tYoung as You Feel\t1940\t60')
['tt0033290', 'Young as You Feel', '1940', '60']
>>> parse_tsv_line('tt0033290\tYoung as You Feel\t1940\t\n')
['tt0033290', 'Young as You Feel', '1940', '']
"""
def int_parse(string):
    if string == "":
        return None
    else:
        return int(string)
"""
>>> int_parse("1940")
1940
>>> int_parse("")
"""
def parse_movie(line):
    row = parse_tsv_line(line)
    return row[:2] + [int_parse(row[2]), int_parse(row[3])]
"""
>>> parse_movie('tt0033290\tYoung as You Feel\t1940\t60\n')
['tt0033290', 'Young as You Feel', 1940, 60]
>>> parse_movie('tt0033290\tYoung as You Feel\t1940\t')
['tt0033290', 'Young as You Feel', 1940, None]
"""
def get_movie_title(movie):
    return movie[1]

def get_movie_year(movie):
    return movie[2]


# Do souboru uložte názvy všech filmů, které byly vydány v zdaném roce.
def store_movies_from_year(year, output_path):
    with open("movies/movie.tsv", encoding="UTF-8") as file1:
        with open(output_path, "w", encoding="UTF-8") as file2:
            for line in file1:
                movie = parse_movie(line)
                if get_movie_year(movie) == year:
                    file2.write(get_movie_title(movie) + "\n")

"""
store_movies_from_year(2000, "2000_movies.tsv")
"""

# Úkol: Vezměte soubor movies/director.tsv:
"""
tt0000009	nm0085156
tt0000147	nm0714557
tt0000502	nm0063413
tt0000574	nm0846879
tt0000591	nm0141150
tt0000615	nm0533958
tt0000630	nm0143333
tt0000675	nm0194088
tt0000679	nm0091767
tt0000679	nm0877783
tt0000838	nm0017074
tt0000842	nm0005717
tt0000846	nm0023107
tt0000850	nm0063413
tt0000850	nm0550220
tt0000859	nm0005717
tt0000862	nm0878467
tt0000867	nm0023107
tt0000868	nm0005717
...
"""
# V souboru je na každém řádku identifikátoru filmu
# přiřazen identifikátor režiséra.
#
# Vytvořte soubor, kde identifikátory budou nahrazeny jmény.
# Použijte k tomu soubory:
#   - movies/person.tsv
#   - movies/movie.tsv
# 
# Začátek požadovaného souboru:
"""
Miss Jerry    Alexander Black
The Corbett-Fitzsimmons Fight    Enoch J. Rector
...
"""

